<template>
  <div v-if="userProfile">
    <q-dialog v-model="uploadAvatar" ref="dialogAvatar" persistent>
      <q-card style="min-width: 300px;">
        <q-card-section class="row items-center">
          <q-file
            accept="image/*"
            v-model="avatar"
            filled bottom-slots
            counter
          >
            <template v-slot:before>
              <q-icon name="account_circle" />
            </template>

            <template v-slot:hint>
              Pilih Gambar
            </template>
          </q-file>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
          <q-btn label="Upload Avatar" color="primary" @click="doUploadAvatar" />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <div v-if="allowProvider">
      <div v-if="userProfile.profile.ktp || userData">
        <div class="q-pa-md" style="width: 80%; background: #4caf50; color: white; margin-top: 50px; margin-left: auto; margin-right: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
          <h6 style="margin: 0px">Informasi Provider</h6>
        </div>

        <div class="q-pa-md" style="width: 80%; padding: 0; margin: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
          <div>
            <p>&nbsp;</p>
            <h6 style="margin-left: 70px; margin-top: 0px; margin-bottom: 10px">Gambar Profil Provider</h6>
            <div class="row">

                <q-avatar size="250px" style=" margin-left: 50px; margin-bottom: 15px" >
                  <img :src="provider.foto || `https://cdn.quasar.dev/img/avatar.png`">
                </q-avatar>
              <div class="col-md-7" style="margin-top: 80px; margin-left: 20px">
                <q-btn color="green" @click="uploadAvatar = true" icon="cloud_upload" label="Pilih Gambar" style="margin-top: 10px"/>
                <p style="font-size: 12px; margin-bottom: 5px">Format gambar yang diijinkan adalah jpg, jpeg & png.</p>
                <p style="font-size: 12px; margin-top: 5px" >Maksimal Ukuran Gambar adalah 2 mb</p>
              </div>
            </div>
          </div>
        </div>

        <div class="q-pa-md" style="width: 80%; padding: 0; margin: auto; margin-top: 10px; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
          <div>
            <p>&nbsp;</p>
            <h6 style="margin-left: 70px; margin-top: 0px; margin-bottom: 10px">Data Provider</h6>
            <div class="q-gutter-y-md" style="width: 85%; margin: auto" >
              <q-input standout="bg-green text-white" hint="Masukan nama toko. Perusahaan atau nama tempat yg andagunakan untuk menjual jasa atau produk (tidak dapat diubah)" v-model="provider.nama_provider" label="Nama Provider"/>
              <q-select
                multiple
                v-model="contohcategori"
                @input="selectCategory"
                :options="category"
                label="Kategori"
                hint="Pilih Kategori bisa lebih dari satu"
              />
              <q-select standout="bg-green text-white" hint="Masukan jenis badan usaha sesuai pilihan, jika belum memiliki jenis badan usaha resmi Masukan Pilihan Perorangan"  v-model="badanUsaha" :options="optionsBadanUsaha"
                        label="Pilih Badan Usaha" />
              <q-input standout="bg-green text-white" hint="Masukan no telepon tempat usaha anda" v-model="provider.no_telp" label="Nomor Telepon"/>
            </div>
            <p>&nbsp;</p>
          </div>
        </div>

        <div class="q-pa-md" style="width: 80%; padding: 0; margin: auto; margin-top: 10px; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
          <div>
            <p>&nbsp;</p>
            <h6 style="margin-left: 70px; margin-top: 0px; margin-bottom: 10px">Data Alamat</h6>
            <div class="q-gutter-y-md" style="width: 85%; margin: auto" >
              <q-select standout="bg-green text-white" ref="pilihKota" @input="getKota" v-model="provinsi" :options="optionsProvinsi" label="Pilih Provinsi" />
              <q-select standout="bg-green text-white" @input="getKecamatan"  v-model="kota" :options="optionsKota" label="Pilih Kabupaten/Kota" />
              <q-select standout="bg-green text-white" @input="getDesa" v-model="kecamatan" :options="optionsKecamatan" label="Pilih Kecamatan" />
              <q-select standout="bg-green text-white" v-model="desa" :options="optionsDesa" label="Pilih Kelurahan" />
              <div class="row">
                <q-input style="padding-right: 5px" class="col-6" standout="bg-green text-white" v-model="provider.rt" label="RT" />
                <q-input style="padding-left: 5px" class="col-6" standout="bg-green text-white" v-model="provider.rw" label="RW" />
              </div>
              <q-input standout="bg-green text-white" v-model="provider.kode_pos" label="Kode Pos" />
            </div>
            <p>&nbsp;</p>
          </div>
        </div>

        <div style="margin-top: 20px; margin-left: auto; margin-right:auto; margin-bottom: 50px; width: 80%">
          <q-btn @click="submitProvider()"  label="Simpan" type="submit" color="green"/>
        </div>
        <p>&nbsp;</p>
      </div>



    </div>
    <div v-else>
      <q-banner inline-actions class="text-white bg-red">
        Anda Belum Bisa Menambahkan Provider, Silahkan Lengkapi Profile
        <template v-slot:action>
          <q-btn color="blue" label="Lengkapi Profile" to="profile" icon="account_circle" />
        </template>
      </q-banner>
    </div>
  </div>
</template>

<script>

  export default {
    name: "Provider",

    data () {
      return {
        contohcategori: [],
        dataCategory: null,
        tab: 'biodata',
        token: "Bearer " + localStorage.getItem("token"),

        name: null,
        age: null,

        accept: false,

        userData: null,
        provider: {},

        uploadAvatar: false,
        avatar: null,
        category: null,

        optionsProvinsi: [],
        provinsi:[],

        optionsKota: [],
        kota:[],

        optionsKecamatan: [],
        kecamatan:[],

        optionsDesa: [],
        desa:[],

        optionsBadanUsaha: [],
        badanUsaha: [],
      }
    },

    methods: {

      selectCategory: function() {
        if (this.contohcategori.length == 0) {
          this.dataCategory = null
        } else if (this.contohcategori.length == 1) {
          this.dataCategory = this.contohcategori[0].value
        } else {
          this.contohcategori.forEach((item, index) => {
            if (index == 0) {
              this.dataCategory = item.value
            } else {
              this.dataCategory = this.dataCategory + ", " + item.value
            }
          })
        }
      },

      getCategory: function() {

      },

      async doUploadAvatar() {
        if (!this.avatar) {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            position: 'top',
            message: 'Silahkan Pilih Foto'
          })
        } else {
          let formData = new FormData();

          formData.append("image", this.avatar);

          this.$q.loading.show()

          let dataAPi = {
            url: "api/provider/image",
            method: "POST",
            headers: {
              Authorization: this.token
            },
            data: formData,
          }

          await this.$axios(dataAPi)
          .then(sukses => {
            this.$q.notify({
              color: 'green-5',
              textColor: 'white',
              icon: 'warning',
              position: 'top',
              message: 'Berhasil Mengubah Foto'
            })

            this.provider = sukses.data
          })
          .catch(error => {
            this.$q.notify({
              color: 'red-5',
              textColor: 'white',
              icon: 'warning',
              position: 'top',
              message: 'Kesalahan Jaringan'
            })
          })
          .then(selalu => { this.$q.loading.hide() })
        }
      },

      submitProvider: function () {
        var data = new FormData();

        data.append('npwp_pemilik', this.userProfile.profile.npwp);
        data.append('email_pemilik', this.userProfile.email);
        data.append('ktp_pemilik', this.userProfile.profile.ktp);
        data.append('nama_provider', this.provider.nama_provider);
        data.append('id_kategori', this.dataCategory);
        data.append('no_telp', this.provider.no_telp);
        data.append('alamat', this.provider.alamat);

        let aksi = true

        if (!this.dataCategory) {
          aksi = false
        }

        if (this.provinsi) {
          data.append('provinsi_id', this.provinsi.value);
        } else {
          aksi = false
        }


        if (this.kota) {
          data.append('kota_id', this.kota.value);
        } else {
          aksi = false
        }

        if (this.kecamatan) {
          data.append('kecamatan_id', this.kecamatan.value);
        } else {
          aksi = false
        }

        if (this.desa) {
          data.append('kelurahan_id', this.desa.value);
        } else {
          aksi = false
        }

        if (this.badanUsaha) {
          data.append('id_badan_usaha', this.badanUsaha.value);
          data.append('badan_usaha', this.badanUsaha.label);
        } else {
          aksi = false
        }


        data.append('rt', this.provider.rt);
        data.append('rw', this.provider.rw);
        data.append('kode_pos', this.provider.kode_pos);

        if (aksi) {
          let config = {
            method: 'post',
            url: 'api/provider/create',
            headers: {
              'Authorization': this.token,
            },
            data : data
          };

          this.$q.loading.show()

          this.$axios(config)
            .then(sukses => {
              this.$q.notify({
                color: 'green-5',
                textColor: 'white',
                icon: 'warning',
                position: 'top',
                message: 'Berhasil Mengubah Data Provider'
              })
            })
            .catch(error => {
              console.log(error);
              this.$q.notify({
                color: 'red-5',
                textColor: 'white',
                icon: 'warning',
                position: 'top',
                message: 'Kesalahan Jaringan'
              })
              this.$q.loading.hide()
            })
            .then(selalu => {
              this.$q.loading.hide()
            })
        } else {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            position: 'top',
            message: 'Periksa Kembali Form Anda !'
          })
        }

      },
      getBadanUsaha() {
        this.$q.loading.show()
        let apiUrl = {
          url : "api/business/select",
          headers: {
            Authorization: this.token
          }
        }

        this.$axios(apiUrl)
          .then(sukses => {
            this.$q.loading.hide();

            let data = sukses.data
            this.optionsBadanUsaha = data



          })
      },

      getProvider() {
        this.$q.loading.show()
        let dataApi = {
          method: "GET",
          url: "api/provider/detail",
          headers: {
            Authorization: this.token
          }
        }

        this.$axios(dataApi)

        .then(sukses => {
          this.loadCategory()
          this.userData = sukses.data
          this.provider = sukses.data.provider

          this.getBadanUsaha()

          if (this.provider.provinsi) {
            this.provinsi = {
              label : this.provider.provinsi.name,
              value : this.provider.provinsi.id
            }
            this.getKota()
          }

          if (this.provider.kota) {
            this.kota = {
              label : this.provider.kota.name,
              value : this.provider.kota.id
            }
            this.getKecamatan()
          }

          if (this.provider.kecamatan) {
            this.kecamatan = {
              label : this.provider.kecamatan.name,
              value : this.provider.kecamatan.id
            }
            this.getDesa()
          }

          if (this.provider.desa) {
            this.desa = {
              label : this.provider.desa.name,
              value : this.provider.desa.id
            }
          }

          if (this.provider.categories) {
            this.provider.categories.forEach(x => {
              let dataCategory = {"label": x.category, "value": x.id };
              this.contohcategori.push(dataCategory)
            })
          }
        })
      },

      loadCategory: function () {


        let dataApi = {
          method: "GET",
          url: "api/category/list-select",
          headers: {
            Authorization: this.token
          }
        }

        this.$axios(dataApi)

          .then(sukses => {
            this.$q.loading.hide()
            this.category = sukses.data
          })
      },

      onSubmit () {
        if (this.accept !== true) {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: 'You need to accept the license and terms first'
          })
        }
        else {
          this.$q.notify({
            color: 'green-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: 'Submitted'
          })
        }
      },

      onReset () {
        this.name = null
        this.age = null
        this.accept = false
      },

      getDesa: function () {
        this.desa = null

        this.$q.loading.show()
        let apiUrl = {
          url : "api/wilayah/desa/" + this.kecamatan.value,
          headers: {
            Authorization: this.token
          }
        }

        this.$axios(apiUrl)
          .then(sukses => {
            this.$q.loading.hide();

            let data = sukses.data.villages
            this.optionsDesa = []

            for (let i = 0; i < data.length; i++) {
              let dataX = {
                label: data[i].name,
                value: data[i].id
              }
              this.optionsDesa.push(dataX)
            }

          })
      },

      getKecamatan: function () {
        this.kecamatan = null
        this.desa = null

        this.$q.loading.show()
        let apiUrl = {
          url : "api/wilayah/kecamatan/" + this.kota.value,
          headers: {
            Authorization: this.token
          }
        }

        this.$axios(apiUrl)
          .then(sukses => {
            this.$q.loading.hide();

            let data = sukses.data.districts
            this.optionsKecamatan = []

            for (let i = 0; i < data.length; i++) {
              let dataX = {
                label: data[i].name,
                value: data[i].id
              }
              this.optionsKecamatan.push(dataX)
            }

          })
      },

      getKota: function () {
        this.kota = null
        this.kecamatan = null
        this.desa = null

        this.$q.loading.show()
        let apiUrl = {
          url : "api/wilayah/kota/" + this.provinsi.value,
          headers: {
            Authorization: this.token
          }
        }

        this.$axios(apiUrl)
          .then(sukses => {
            this.$q.loading.hide();

            let data = sukses.data.cities
            this.optionsKota = []

            for (let i = 0; i < data.length; i++) {
              let dataX = {
                label: data[i].name,
                value: data[i].id
              }
              this.optionsKota.push(dataX)
            }

          })
      },

      getProvinsi() {
        this.$q.loading.show()
        let apiUrl = {
          url : "api/wilayah/provinsi",
          headers: {
            Authorization: this.token
          }
        }

        this.$axios(apiUrl)
          .then(sukses => {
            this.$q.loading.hide();

            let data = sukses.data

            for (let i = 0; i < data.length; i++) {
              let dataX = {
                label: data[i].name,
                value: data[i].id
              }
              this.optionsProvinsi.push(dataX)
            }

          })
      },
    },

    beforeMount() {
      if (this.$q.platform.is.mobile) {
        this.$router.push("/provider-m")
      }
      this.getProvider()
    },

    mounted() {
      this.getProvinsi();
    },

    computed: {
      userProfile: {
        get () {
          return this.$store.getters["user/getUser"]
        },
        set (val) {

        }
      },

      allowProvider: function () {
        if (this.userProfile.profile) {
          if (this.userProfile.profile.ktp) {
            return true;
          } else {
            return false;
          }
        } else {
          return false;
        }
      }
    }
  }

</script>

<style scoped>

</style>
